program biset;

uses crt,printer;

type
   vettore=array[1..20] of real;


const
  npassi=10;
  deltax=0.0001;

var
  p,i1,step,s1,d1,deriv,y:real;
  r,risp:char;
  i,j,k,t:integer;
  s,d:vettore;
  ok:boolean;

function pot(b1:real;e1:integer):real;
var
  a1:real;
  i1:integer;
begin
  if e1=0 then pot:=1
  else begin
    a1:=1;
    for i1:=1 to e1 do a1:=b1*a1;
    pot:=a1;
  end;
end;

function f(x:real):real;
begin
  f:=sqrt(2+x)-x;
end;

function g(x:real):real;
begin
   g:=f(x)+x;
end;

function g1(x:real):real;
begin
  g1:=(g(x+deltax)-g(x))/deltax;
end;

begin
  clrscr;
  gotoxy(25,1);
  writeln('Immissione di intervalli di ricerca');
  i:=1;
  gotoxy(1,i+1);write(i:3,' - Ancora intervalli (S/N) '); readln(risp);
  risp:=upcase(risp);
  while risp='S' do begin
    gotoxy(40,i+1);write('SINISTRO: '); readln(s[i]);
    gotoxy(60,i+1);write('DESTRO '); readln(d[i]);
    i:=i+1;
    gotoxy(1,i+1);write(i:3,' - Ancora intervalli (S/N) '); readln(risp);
    risp:=upcase(risp);
  end;
  
  {filtro degli intervalli accettabili}
  i:=i-1;
  j:=0;
  for k:=1 to i do
      if f(s[k])*f(d[k])>0 then writeln('  Col metodo della bisettrice non si trovano soluz. nell''intervallo ', k,'')
      else begin
        writeln('  Accettato l''intervallo ', k,'');
        j:=j+1;
        s[j]:=s[k];
        d[j]:=d[k];
      end;
  gotoxy(40,24);writeln('Un tasto per continuare');
  r:=readkey;

  for K:=1 to j do begin
      clrscr;
      s1:=s[k];
      d1:=d[k];
      writeln('Intervallo: ', k);
      writeln(k:2,' - Intervallo[',s1:12:7,',',d1:12:7,']');
      step:=(d1-s1)/5;
      i1:=s1;
      ok:=true;
      writeln('Alcune derivate, con step uguale a 1/5 dell''intervallo');
      while i1<d1 do begin
        deriv:=g1(i1);

        writeln(deriv:10:4);
        if deriv>=1 then ok:=false;
        i1:=i1+step;
      end;
      if ok then begin
        write('scrivi il punto x 0 interno all''intervallo');
        repeat
           gotoxy(44,9); writeln('          ');
           gotoxy(44,9); readln(p);
        until (p<d1) and (p>s1);
        for t:=1 to npassi do begin
          y:=g(p);
          p:=y;
          writeln('x',t:2,' vale ',p:18:9);
        end;
      end
      else
         writeln('Non  y''<1 quindi non  applicabile il teorema');
  end;
  r:=readkey;
end.
